<p align="center">
  <a href="https://omicron.devillers.nl">
    <img alt="Big O(micron) Visualizer" width="80" src="https://omicron.devillers.nl/logo.png" />
  </a>
</p>
<h1 align="center">
  Big O(micron) Visualizer
</h1>

<p align="center">
  <a href="https://github.com/MartinDevillers/omicron/blob/master/LICENSE">
    <img src="https://img.shields.io/badge/license-MIT-blue.svg" alt="Big O Visualizer is released under the MIT license." />
  </a>
</p>

An interactive web-based tool that visualizes the time complexity of algorithms by running them against various data sets, counting the operations and plotting the results in a chart.

[**See it in action!**](https://omicron.devillers.nl)

## ✨ Features

- Common sorting algorithms (more coming soon™)
- Various dataset generators (randomized; sorted; reversed; zigzag; etc)
- Common runtime complexities
- Best-case, average-case and worst-case calculation
- Fully customizable through the usage of Gatsby Themes (and Theme UI)
- Light Mode / Dark Mode
- Typography driven, minimal style
- Offline Support & WebApp Manifest

## 🚀 Getting Started

1. **Clone this repo.**

Use the GIT CLI to clone this repository.

```sh
git clone https://github.com/MartinDevillers/omicron.git
```

2. **Start developing.**

Navigate into your freshly cloned directory and start it up.

```sh
cd omicron
gatsby develop
```

3. **Open the code and start customizing!**

Big O Visualizer is now running at `http://localhost:8000`!
